Package: GraphAT
Title: Graph Theoretic Association Tests
Version: 1.83.0
Date: 2012-04-27
Author: R. Balasubramanian, T. LaFramboise, D. Scholtens
Description: Functions and data used in Balasubramanian, et al. (2004)
Maintainer: Thomas LaFramboise <tlaframb@hsph.harvard.edu>
Depends: R (>= 2.10), graph, methods
Imports: graph, MCMCpack, methods, stats
License: LGPL
biocViews: Network, GraphAndNetwork
git_url: https://git.bioconductor.org/packages/GraphAT
git_branch: devel
git_last_commit: 581549b
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-30
NeedsCompilation: no
Packaged: 2025-10-30 21:23:34 UTC; biocbuild

#permutes rows and columns in matrix
#equivalent to node permutation in a graph

permNodesM2M<-function(mat){
	
	ord<-sample(dim(mat)[1],dim(mat)[1],replace=FALSE)
	newmat<-mat[ord,ord]
	return(newmat)
}

### PURPOSE: Obtain node and edge permutation test p values 
### INPUT 1: act.mat = adjacency matrix whose nodes/edges are to be permuted
### INPUT 2: nonact.mat = adjacency matrix whose nodes/edges are not permuted
### INPUT 3: Number of realizations generated by random permutation of nodes or
###          edges
### OUTPUT:  (P value from Edge permutation, P value from Node permutation)	 

getpvalue <- function(act.mat, nonact.mat, num.iterations=1000)
{
	obs.rand.edges <- c()
	obs.rand.nodes <- c()

	intmat <- nonact.mat*act.mat
	obs.data <- sum(intmat)/2

	for (i in 1:num.iterations)
	{

		##### Permuting the edges
		litmatPE <- permEdgesM2M(act.mat)
		intmatPE <- nonact.mat*litmatPE
		obs.rand.edges <- c(obs.rand.edges, sum(intmatPE)/2)
		
		##### Permuting the nodes 
		litmatPN <- permNodesM2M(act.mat)
		intmatPN <- nonact.mat*litmatPN
		obs.rand.nodes <- c(obs.rand.nodes, sum(intmatPN)/2)
		
	}

	p.value <- c(sum(obs.rand.edges >= obs.data)/num.iterations, sum(obs.rand.nodes >= obs.data)/num.iterations)
	return(p.value) 
}

permPower<-function(psi=1,clsizes, nedge, nhyper=100, nperms=1000)
{

#function to  randomly select a subset of the edges of a graph
#takes an adjacency matrix called mat and number samp of edges to select
## Modified from Denise's permEdgesM2M

sampEdgesM2M<-function(mat, samp){

uniqE<-which(lower.tri(mat)==TRUE)
newE<-sample(uniqE,samp,replace=FALSE)
newmat<-matrix(0,dim(mat)[1],dim(mat)[2])
newmat[newE]<-1
newmat<-newmat+t(newmat)
return(newmat)
}


## First draw from noncentral hypergeometric distribution:
m1<-nedge
n1<-sum(choose(clsizes[clsizes>1],2))
n2<-choose(sum(clsizes),2)-n1
Xs<-rnoncenhypergeom(nhyper, n1, n2, m1, psi)

## Now make adjacency matrix for cluster graph and its complement
clustMat<-makeClustM(clsizes)
complMat<-(1-clustMat)-outer((1:sum(clsizes)),(1:sum(clsizes)),"==")

## Now a function to generate adjaceny matrix representing some X~noncenhyper
nCenMat<-function(x){
intraMat<-sampEdgesM2M(clustMat,x)
interMat<-sampEdgesM2M(complMat,m1-x)
return(intraMat+interMat)} 

### Now we define a function that returns a logical 2-vector indicating
### whether permedges and permnodes techniques, resp., reject null.
reject<-function(x){
randMat<-nCenMat(x)
cmpr.pedge<-function(num){
newM<-permEdgesM2M(randMat) ### Note that here we could use rhypergeom instead
return(x<=sum(newM*clustMat)/2)}
cmpr.pnode<-function(num){
newM<-permNodesM2M(randMat)
return(x<=sum(newM*clustMat)/2)}
return(c(mean(sapply(1:nperms,cmpr.pedge))<.05,
mean(sapply(1:nperms,cmpr.pnode))<.05))}

## The vector of whether the null was rejected. Top row for permuting edges
result<-sapply(Xs,reject)

## Return the approx. power and CI's
pws<-apply(result,1,mean)
return(list(power.permedge=pws[1],power.permnode=pws[2],
CI.permedge=binom.test(sum(result[1,]),dim(result)[2])$conf.int[1:2],
CI.permnode=binom.test(sum(result[2,]),dim(result)[2])$conf.int[1:2]))}

#function to make an adjacency matrix for a cluster graph
#nvec is a vector of the size of the clusters

makeClustM <- function(nvec){

	nClust<-length(nvec)

	c1mat<-1-diag(nvec[1])

	if(nClust>1){
	for (n in 2:nClust){
	
		c2mat<-1-diag(nvec[n])
	   	betweenmat<-matrix(0,nvec[n],sum(nvec[1:(n-1)]))
		c1mat<-cbind(rbind(c1mat,betweenmat),
				rbind(t(betweenmat),c2mat))
	}
	}
	return(c1mat)
}

#function to permute the edges of a graph
#takes an adjacency matrix called mat

permEdgesM2M<-function(mat){

	numE<-sum(mat)/2
	uniqE<-which(lower.tri(mat)==TRUE)
	newE<-sample(uniqE,numE,replace=FALSE)
	newmat<-matrix(0,dim(mat)[1],dim(mat)[2])
	newmat[newE]<-1
	newmat<-newmat+t(newmat)
	return(newmat)
}

#V is list of node names
#mat is symmetric matrix indicating presence of edges

mat2UndirG<-function(V,mat){

	tmat<-which(mat==1,arr.ind=TRUE)
	numN<-length(V)
	numE<-dim(tmat)[1]

	rval <- vector("list", length = numN)
    	for (i in 1:numE) {
        	rval[[tmat[i, 1]]]$edges <- c(rval[[tmat[i, 1]]]$edges, 
            	tmat[i, 2])
        	ln <- length(rval[[tmat[i, 1]]]$edges)
        	rval[[tmat[i, 1]]]$weights <- c(rval[[tmat[i, 1]]]$weights, 
            	1)
        	names(rval[[tmat[i, 1]]]$weights)[ln] <- tmat[i, 2]
	}
    	names(rval) <- V
    	g1<-new("graphNEL", nodes = V, edgeL = rval)
	edgemode(g1)<-"undirected"
	return(g1)
}

\name{getpvalue} 

\alias{getpvalue} 

\title{Function to obtain P values from the Edge permutation and Node
permutation tests respectively}

\description{The function takes as inputs two adjacency matrices. Let X denote the observed number of 
edges in common between the two adjacency matrices.  To
test the significance of the correlation between the two data sources,
the function performs N random edge permutations and random node
permutations respectively. For each permutation test, the function
outputs the proportion of N realizations that resulted in X edges or more at the intersection of the two datasources}

\usage{getpvalue(act.mat, nonact.mat, num.iterations = 1000)}

\arguments{ 

\item{act.mat}{Adjacency matrix corresponding to first data
source. That is, the i,j element of this matrix is 1 if data source
one specifies a functional link between genes i and j }

\item{nonact.mat}{Adjacency matrix corresponding to first data
source. That is, the i,j element of this matrix is 1 if data source
two specifies a functional link between genes i and j}

\item{num.iterations}{Number of realizations from random edge (node)
permutation to be obtained}
}
\details{We note that the first adjacency matrix, denoted act.mat is
the data source that is permutated with respect to edges or notes}

\value{A vector of length 2, where the first element is the P value
from Random Edge Permutation and the second element is the P value
from Random Node Permutation}

\author{Raji Balasubramanian \email{rbalasub@hsph.harvard.edu}}

\seealso{\code{\link{permEdgesM2M}}, \code{\link{permNodesM2M}}, \code{\link{makeClustM}}}
\examples{
act.mat <- matrix(0,3,3)
act.mat[2,1] <- 1 
act.mat[3,1] <- 1
nonact.mat  <- matrix(0,3,3)
nonact.mat[2,1] <- 1
nonact.mat[3,2] <- 1
p.val <- getpvalue(act.mat, nonact.mat, num.iterations = 100)
print(p.val)
}

\keyword{htest}

\name{giaever}
\alias{giaever}
\docType{data}
\title{Yeast Gene-Knockout Fitness Data}
\description{ This data set contains fitness deficiency scores from gene knockout experiments involving yeast grown under a variety of altered environments (e.g. acid, heat, sorbitol, etc.)  }
\usage{data(giaever)}
\format{A matrix whose rows are the 5922 genes knocked out and whose columns are the 32 experimental conditions.}
\source{\url{http://gobi.lbl.gov/YeastFitnessData}}
\references{Giaever, G. et al. 2002 ``Functional profiling of the Saccharomyces cerevisiae genome.'' Nature \bold{418}, 387--391. 
}
\examples{
data(giaever)

## Find the 3000 most variable genes, according to sd/mean:
varMeas <- function(vec, na.rm=TRUE) 
{
    if(na.rm)
      vec <- vec[!is.na(vec)]
    if(length(vec) == 0)
      measure <- NA
    else
      measure <- sd(vec)/mean(vec)
    return(measure)
}

variability <- apply(giaever, 1, varMeas)

rks <- rank(variability)

giaever3000 <- giaever[rks>length(rownames(giaever))-3000,]
}
\keyword{datasets}

\name{mRNAclusters}
\alias{mRNAclusters}
\docType{data}
\title{Yeast mRNA Expression Data Cluster Memberships}
\description{ This data set contains cluster membership for yeast genes clustered using mRNA expression from a microarray experiment in Causton, et al. Molecular Biology of the Cell (2001). The 3000 most variable genes were clustered using k-means with 30 clusters.}
\usage{data(mRNAclusters)}
\format{A data frame whose rows are the 3000 genes and whose two columns are gene name and cluster membership number.}
\source{\url{http://web.wi.mit.edu/young/environment}}
\references{Causton, H. C. et al. 2001 ``Remodeling of Yeast Genome Expression in Response to Environmental Changes.'' Molecular Biology of the Cell \bold{12}, 323--337. 
}
\examples{
data(mRNAclusters)

## Compute the adjacency matrix for the corresponding cluster graph:
mRNAMat<-clust2Mat(mRNAclusters[,2])
}
\keyword{datasets}

\name{permPower}
\alias{permPower}
\title{Function to compute estimated probability of detecting preferential
connection of intracluster nodes}
\description{
  This function simulates graphs from the alternative hypothesis
of preferential connection of intracluster nodes.  For each graph, it runs a node and edge permutation test.  The estimated ``power'' of each test is the proportion of graphs that the test rejects the null hypothesis of no preferential connection of intracluster edges.  }
\usage{
permPower(psi=1,clsizes, nedge, nhyper=100, nperms=1000)
}
\arguments{
  \item{psi}{The non-centrality parameter for the noncentral hypergeometric distribution used to simulate the graphs.}
\item{clsizes}{A vector of cluster sizes.}
\item{nedge}{The number of edges in each graph.}
\item{nhyper}{The number of noncentral hypergeometric graphs simulated to estimate "power".}
\item{nperms}{The number of permutations used for each run of the edge and node permutation tests.}
}
\details{
  The function first generates nhyper realizations of a noncentral hypergeometric(nedge,n,k,psi) random variable, where n is the number of node pairs and k is the number of intracluster node pairs.  For each realization x, a graph with n edges, x of which are intracluster, is generated.  The edge and node permutation tests (with nperms permutations each) are performed on each graph.  The estimated ``power'' of each test is the proportion of graphs for which the test rejects the null hypothesis of no preferential connection of intracluster nodes (at the 5\% level).  The 95\% confidence intervals for the power levels are also computed.  }
\value{A list with four components:
  \item{power.permedge}{Estimated ``power'' for edge permutation test.}
  \item{power.permnode}{Estimated ``power'' for node permutation test.}
\item{CI.permedge}{Vector giving 95\% confidence interval for edge permutation test power.}
\item{CI.permnode}{Vector giving 95\% confidence interval for node permutation test power.}
}
\author{Tom LaFramboise \email{tlaframb@hsph.harvard.edu}}
\seealso{\code{\link{permEdgesM2M}}, \code{\link{permNodesM2M}}, \code{\link{makeClustM}}}
\examples{
permPower(psi=5,clsizes=c(1,2,3,4),nedge=10,nhyper=100,nperms=100)
}
\keyword{htest}

\name{clust2Mat}
\alias{clust2Mat}
\title{Function to compute adjacency matrix of cluster graph given a vector of cluster memberships}
\description{
  Given a list of cluster memberships, this function computes the adjacency matrix for the associated cluster graph.  The adjacency matrix is a matrix whose rows and columns are the nodes of the cluster graph and whose entries are 0's or 1's.  A 1 entry indicates that the corresponding nodes are connected, and a 0 indocates that they are not.  }
\usage{
clust2Mat(memb)
}
\arguments{
  \item{memb}{ A numeric vector, with each entry representing a node, the entry's value being the number of the cluster to which that node belongs.}} 
\details{
  Given a vector of cluster membership numbers, where the number of entries is the number of nodes n, the function computes an nxn ``adjacency matrix'' for the corresponding cluster graph.  The cluster graph is the graph in which two nodes are connected by an edge if and only if they are members of the same cluster.  The adjacency matrix for the graph has rows and columns representing the nodes, in the same order as the input vector.  The (i,j) entry is 1 if and only if node i and node j are in the same cluster.  Otherwise, the entry is 0.  By convention, diagonal entries are 0.  }
\value{An nxn adjacency matrix for the cluster graph, where n=length of cluster membership input vector memb.}
\author{Tom LaFramboise \email{tlaframb@hsph.harvard.edu}}
\seealso{\code{\link{makeClustM}}}
\examples{
memberships<-c(1,2,3,1,2,3,1,2,3,4)
clust2Mat(memberships)}
\keyword{data}

\name{makeClustM}
\alias{makeClustM}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Make an adjacency matrix for a cluster graph}
\description{
This function takes a vector of cluster sizes and returns an adjacency matrix for a graph in which edges connect nodes if they are members of the same cluster.
}
\usage{
makeClustM(nvec)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{nvec}{A vector of cluster sizes}
}
%\details{
%  ~~ If necessary, more details than the __description__  above ~~
%}
\value{
A square adjacency matrix with the number of rows and columns equal to the sum of nvec.  An entry of "1" in the ith row and jth column indicates that node i and node j are members of the same cluster.  All other entries are "0".
}
\references{Balasubramanian, et al. (2004) A graph theoretic approach to integromics - integrating disparate sources of functional genomics data.}
\author{Denise Scholtens }
%\note{ ~~further notes~~ }

 %~Make other sections like Warning with \section{Warning }{....} ~

\seealso{\code{\link{clust2Mat}}}
\examples{
a <- makeClustM(c(2,3,4))
}
\keyword{graphs}

\name{causton}
\alias{causton}
\docType{data}
\title{Yeast mRNA Expression Data}
\description{ This data set contains mRNA expression from a microarray experiment involving yeast grown under a variety of altered environments (e.g. acid, heat, sorbitol, etc.)  }
\usage{data(causton)}
\format{A matrix whose rows are the 6015 genes and whose columns are the 45 experimental conditions.}
\source{\url{http://web.wi.mit.edu/young/environment}}
\references{Causton, H. C. et al. 2001 ``Remodeling of Yeast Genome Expression in Response to Environmental Changes.'' Molecular Biology of the Cell \bold{12}, 323--337. 
}
\examples{
data(causton)

## Find the 3000 most variable genes, according to sd/mean:

varMeas<-function(vec) sd(vec)/mean(vec)
variability<-apply(causton,1,varMeas)

rks<-rank(variability)

causton3000<-causton[rks>length(rownames(causton))-3000,]
}
\keyword{datasets}

\name{mat2UndirG}
\alias{mat2UndirG}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Change graph representations}
\description{
A function to turn an adjacency matrix for a graph into a graphNEL object.
}
\usage{
mat2UndirG(V, mat)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{V}{A vector of node names}
  \item{mat}{A square symmetric matrix indicating the presence of edges}
}
\details{
\code{mat} is a square matrix with rows and columns corresponding to nodes in the graph.  Entries of "0" indicate the lack of an edge.  Since this is making an undirected graph, \code{mat} must be symmetric.

}
\value{
A graphNEL object.
}
\references{Balasubramanian, et al. (2004) A graph theoretic approach to integromics - integrating disparate sources of functional genomics data.}
\author{Denise Scholtens}

%\seealso{ ~~objects to See Also as \code{\link{~~fun~~}}, ~~~ }
\examples{
library(graph)
a <- matrix(c(0,1,1,1,1,0,0,0,1,0,0,0,1,0,0,0),ncol=4)
ag <- mat2UndirG(V=letters[1:4],mat=a)
}
\keyword{graphs}

\name{depthmat} 
\alias{depthmatBP}
\alias{depthmatCC}
\alias{depthmatMF}
\docType{data}

\title{Matrices of depth of association for pairs of YEAST genes with
respect to each of the BP,CC and MF ontologies of the GO database}

\description{ This matrix of depths is used to obtain the predictome
data in the paper. This is a symmetric matrix, where the i,j element
corresponds to is the maximum depth of all annotations shared by genes
i and j. Note that depth of a term in
a specific Gene Ontology (BP, CC, MF) is defined as the shortest path
between the term and the root node, where distance between nodes is
measured by the number of edges traversed. Row labels of the matrix
can be obtained by the row.names() function}

\usage{data(depthmatBP)} 

\format{Each of three matrices, namely depthmatBP.rda, depthmatCC.rda,
depthmatMF.rda is a symmetric matrix whose rows and columns correspond to
specific YEAST genes (see row labels using row.names()). The i,j entry
of each matrix refers to the maximum depth shared by genes i and j under each of the BP, CC and MF ontlogies respectively}

\source{\url{http://www.geneontology.org}}

\references{} 
\examples{ 
data(depthmatBP)
print(row.names(depthmatBP)[1:10])
}
\keyword{data}

\name{perms}
\alias{permEdgesM2M}
\alias{permNodesM2M}
\title{Randomly permute edges or node labels in a graph}
\description{
Given an adjacency matrix for a graph, \code{permEdgesM2M} will return an adjacency matrix after an Erdos-Renyi random permutation of the edges in the graph.  \code{perNodesM2M} will return an adjacency matrix for a graph with identical structure, but with the node labels permuted.
}
\usage{
permEdgesM2M(mat)
permNodesM2M(mat)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{mat}{A square adjacency matrix for a graph.}
}
%\details{
%  ~~ If necessary, more details than the __description__  above ~~
%}
\value{
A square adjacency matrix for the new graph, subject to a random permutation of the edges or nodes.
}
\references{Balasubramanian, et al. (2004) A graph theoretic approach to integromics - integrating disparate sources of functional genomics data.}
\author{Denise Scholtens}
%\note{ ~~further notes~~ }

% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{\code{\link{permPower}}}
\examples{
g <- matrix(c(0,1,1,1,1,0,0,0,1,0,0,0,1,0,0,0),nrow=4)

g1 <- permEdgesM2M(g)
g2 <- permNodesM2M(g)

}
\keyword{graphs}

\name{Phenoclusters}
\alias{Phenoclusters}
\docType{data}
\title{Yeast Gene-Knockout Fitness Data Cluster Memberships}
\description{ This data set contains cluster memberships for yeast genes clustered using fitness deficiency scores from gene knockout experiments from Giaever et al. Nature (2002). The 3000 most variable genes were clustered using k-means with 30 clusters}
\usage{data(Phenoclusters)}
\format{A matrix whose rows are the 3000 genes and whose two columns are gene name and cluster membership number.}
\source{\url{http://gobi.lbl.gov/YeastFitnessData}}
\references{Giaever, G. et al. 2002 ``Functional profiling of the Saccharomyces cerevisiae genome.'' Nature \bold{418}, 387--391. 
}
\examples{
data(Phenoclusters)

## Compute the adjacency matrix for the corresponding cluster graph:
phenoMat<-clust2Mat(Phenoclusters[,2])

}
\keyword{datasets}

\name{cellcycle}
\alias{ccCM}
\alias{nNamescc}
\docType{data}
\title{Cell-Cycle Cluster Matrix}
\description{
An adjacency matrix in which 
}
\usage{data(ccCM)}
\format{
\code{ccCM} is a symmetric matrix with 2885 columns and 2885 rows.

\code{nNamescc} is a vector of 2885 gene names.
}
\details{
Cho, et al. discuss the k means clustering of 2885 Saccharomyces genes into 30 clusters with measurements taken over two synchronized cell cycles.  \code{nNamescc} is a vector of the 2885 gene names.  \code{ccCM} is an adjacency matrix in which a "1" in the ith row and jth column indicates that gene i and gene j belong to the same cluster.  All other entries are 0.  These data are integrated with phenotypic data and GO data in Balasubramanian, et al (2004).  

}
\source{
Balasubramanian R, LaFramboise T, Scholtens D, Gentleman R. (2004) A graph theoretic approach to integromics - integrating disparate sources of functional genomics data
}
\references{
Cho, et al. (1998) A genome-wide transcriptional analysis of the mitotic cell cycle.  Molecular Cell, 2, 65-73.

Tavazoie, et al. (1999) Systematic determination of genetic network architecture. Nature Genetics, 22, 281-285.
}
\examples{
data(ccCM)

}
\keyword{datasets}
